datablock ProjectileData(TF2WranglerProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Generic;
   radiusDamageType    = $DamageType::Generic;
   
   soundProfile = "";

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse	  = 50;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 2500;
   fadeDelay           = 0;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(TF2WranglerItem)
{

	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-ons/Weapon_Sentry/wrangler.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TF2 Wrangler";
	iconName = "Add-ons/Weapon_Sentry/icon_controller";
	doColorShift = false;
	colorShiftColor = "0.4 0.5 0.6 1.000";

	 // Dynamic properties defined by the scripts
	image = TF2WranglerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TF2WranglerImage)
{
   // Basic Item properties
   shapeFile = "Add-ons/Weapon_Sentry/wrangler.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TF2WranglerItem;
   ammo = "";
   projectile = TF2WranglerProjectile;
   projectileType = Projectile;

   raycastWeaponRange = 3000;
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = LaserPointProjectileA;
   raycastExplosionBrickSound = "";
   raycastExplosionPlayerSound = "";
   raycastDirectDamage = 0;
   raycastDirectDamageType = $DamageType::Generic;

    //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = WranglerItem.colorShiftColor;
   
   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateSequence[0]		= "Activate";
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTransitionOnTimeout[1]		= "Ready";
	stateTimeoutValue[1]			= 0.01;
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";
	stateFire[1]                    = true;
	stateScript[1]					= "onReady";

	stateName[2]                    = "Fire";
	stateTransitionOnTriggerDown[2]	= "Fire";
	stateTransitionOnTriggerUp[2]	= "StopFire";
	stateTimeoutValue[2]            = 0.05;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= sentryHealSound;

	stateName[3] 			= "StopFire";
	stateTimeoutValue[3]		= 0.01;
	stateTransitionOnTimeout[3]	= "Ready";
	statescript[3]				= "onStopFire";
};

function TF2wranglerImage::onUnMount(%this, %obj, %slot)
{
	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		if(sentryGroup.getObject(%i).sentryOwner == %obj.client)
		{
			%sentry = sentryGroup.getObject(%i);
			%sentry.setimagetrigger(0,0);
			%sentry.target = "";
		}
	}
}

function TF2wranglerImage::onReady(%this, %obj, %slot)
{
	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		if(sentryGroup.getObject(%i).sentryOwner == %obj.client)
		{
			Parent::onFire(%this,%obj,%slot);
			//%obj.client.setControlObject(sentryGroup.getObject(%i));
			%sentry = sentryGroup.getObject(%i);
			%sentry.setAimLocation(%obj.aimlocation);
			%sentry.setimagetrigger(0,0);
			%sentry.target = "";
		}
	}
}

function TF2wranglerImage::onFire(%this, %obj, %slot)
{
	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		if(sentryGroup.getObject(%i).sentryOwner == %obj.client)
		{
			Parent::onFire(%this,%obj,%slot);
			//%obj.client.setControlObject(sentryGroup.getObject(%i));
			%sentry = sentryGroup.getObject(%i);
			%sentry.setAimLocation(%obj.aimlocation);
			%sentry.setimagetrigger(0,1);
			%sentry.target = "";
		}
	}
}

function TF2wranglerImage::onStopFire(%this, %obj, %slot)
{
	for(%i = 0; %i < sentryGroup.getCount(); %i++)
	{
		if(sentryGroup.getObject(%i).sentryOwner == %obj.client)
		{
			//%obj.client.setControlObject(sentryGroup.getObject(%i));
			%sentry = sentryGroup.getObject(%i);
			%sentry.setAimLocation(%obj.aimlocation);
			%sentry.setimagetrigger(0,0);
			%sentry.target = "";
		}
	}
}

function TF2WranglerImage::onHitObject(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
   if(!isObject(%col))
      return;
   %obj.aimlocation = %pos;
}